(*Ŀ
  Source                                                                  
                                                                  
                                                                            
 Matthias Koeppe              (currently out of witty quotes)               
 mkoeppe@moose.boerde.de                                                    
 100331.174@compuserve.com                                                  
 ## CrossPoint v3.02 ##                                                     
                                                                            
                    Amlior et traduit en franais par                     
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
              Cre une liste des disques valides et affiche leur type       
*)
{$G+}

uses EcranTxt;

const
  dtInvalid   = 0;
  dtDisquette = 1;
  dtDisqueDur = 2;
  dtDisqueRAM    = 3;
  dtDisqueReseau = 4;
  dtSubstDrive = 5;
  dtCDRom = 6;

var
  i,NbrDisque: byte;
  ListeDisqueValide: array[0..25] of char;

function DisqueValide (Disque: char): Boolean; assembler; asm
  mov ah,19h          { Save the current drive in BL }
  int 21h
  mov bl,al

  { Change de disque }
  mov dl,[disque]
  sub dl,'A'
  mov ah,0Eh
  int 21h

  { Lit le disque courant }
  mov ah,19h            { Retrieve what DOS thinks is current }
  int 21h
  mov cl,FALSE
  cmp al,dl             { Is the current drive the given drive? }
  jne @Exit

  mov cl,TRUE           { It is, so the drive is valid }
  mov dl,bl             { Restore the old drive }
  mov ah,0Eh
  int 21h
@Exit:
  xchg ax,cx            { Put the return value into AX }
end;

function LecteurCDRom(Drive: Char): Boolean; near; assembler;
var map: array[0..25] of Byte;
asm
	mov	bx, ss
	mov	es, bx
	lea	bx, map
	mov	di, bx
	cld
	mov	cx, 26/2
	mov	ax, 0FFFFH
	rep	stosw
	mov	ax, 150DH
	int	2FH
	lea	di, map
	mov	al, 1		{ Assume it is a CD ROM }
	mov	dh, Drive
	sub	dh, 'A'
@@1:
	mov	dl, es:[bx]
	cmp	dl, dh
	jz	@@0		{ Found drive letter }
	inc	dl
	jz	@@2		{ End of list }
	inc	bx
	jmp	@@1
@@2:
	mov	al, 0
@@0:
end;

function DisqueFixe (Disque: Char) : Boolean; assembler; asm
  mov ax,4408h
  mov bl,[Disque]
  sub bl,'A' - 1
  int 21h
  jnc @exit
  mov al,1              { On error assume it's fixed }
@exit:
end;

function DisqueEnReseau (Drive: Char): Boolean; assembler; asm
  mov ax, 4409H
  mov bl, Drive
  sub bl, 'A' - 1
  int 21h
  mov al,FALSE                    { Assume it's not remote }
  jc @Exit

  shr dx,12                   { Get bit 12 }
  mov al,dl
  and al,1
@Exit:
end;

function IsSubst(Drive: Char): Boolean; assembler; asm
  mov ax, 4409H
  mov bl,[Drive]
  sub bl, 'A' - 1
  int 21h
  mov al,FALSE		{ Assume it's not remote }
  jc @Exit

  shr dx, 15            { Get bit 15 }
  mov al, dl
  and al, 1
@Exit:
end;

function LitTypeDisque (Disque: char) : string; begin
  LitTypeDisque := 'Invalide';
  if not DisqueValide (Disque) then exit;

  if LecteurCDRom(Disque) then LitTypeDisque := 'Lecteur de CD-Rom' else
  if IsSubst(Disque) then LitTypeDisque := '??? Subst Disque ???' else
  if DisqueEnReseau(Disque) then LitTypeDisque := 'Lecteur en rseau' else
  if DisqueFixe (Disque) then LitTypeDisque := 'Disque dur' else
    LitTypeDisque := 'Lecteur de disquette';
end;

begin
  EffaceEcranTxt;

  NbrDisque := 0;
  for i := 0 to 25 do if DisqueValide ( Chr (Ord('A') +i) ) then begin
    ListeDisqueValide[NbrDisque] := Chr (Ord('A') +i);
    inc (NbrDisque);
  end;

  for i := 0 to NbrDisque-1 do begin
    Ecrit ('Disque valide : '''); EcriTc (ListeDisqueValide[i]+':',10);
    Ecrit (''' -> '); EcriTcr (LitTypeDisque(ListeDisqueValide[i]),15);
  end;
end.